#include "stdafx.h"
#include "MainWnd.h"

CMainWnd::CMainWnd():
m_View(&m_wndStatus)
{
}

CMainWnd::~CMainWnd()
{
}

LRESULT CMainWnd::OnCreate(UINT nMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    HRESULT hr = m_View.Create(*this);
    if(FAILED(hr))
        return -1;

    // Status bar
    m_wndStatus.Attach( CreateStatusWindow( WS_CHILD | WS_VISIBLE,
        L"Application started.", m_hWnd, idStatusBar ) );
    if( NULL == m_wndStatus.m_hWnd )
        return -1;

    LPCTSTR strHelp = L"Left-click: simulate movement\n"
        L"Right click: place turret\n"
        L"Ctrl+right click: remove turret\n"
        L"Enter: cycle maps\n"
        L"F5: update the whole map at once";
    MessageBox(strHelp, L"Controls", MB_OK | MB_ICONINFORMATION );
    return 0;
}

LRESULT CMainWnd::OnDestroy(UINT nMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    PostQuitMessage(0);
    return 0;
}

LRESULT CMainWnd::OnSize( UINT nMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled )
{
    if(SIZE_MAXIMIZED != wParam && SIZE_RESTORED != wParam)
        return 0;

    m_wndStatus.SendMessage(WM_SIZE, 0, 0);

    const CRect rc = GetEffectiveClientRect();
    m_View.MoveWindow(rc);
    return 0;
}

LRESULT CMainWnd::OnSetFocus( UINT nMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled )
{
    m_View.SetFocus();
    return 0;
}

LRESULT CMainWnd::OnGetMinMaxInfo( UINT nMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled )
{
    return 0;
}

HRESULT CMainWnd::Create( int nCmdShow )
{
    m_hMenu = LoadMenu( _AtlBaseModule.GetModuleInstance(),
        MAKEINTRESOURCE( IDM_PATHFINDINGDEMO ) );
    if( NULL == m_hMenu )
        return GetLastHr();

    HWND w = __super::Create( NULL, NULL, L"Pathfinding Demo",
        dwWindowStyle, 0, m_hMenu );
    if(NULL == w)
        return GetLastHr();
    if(!ShowWindow(nCmdShow))
        return GetLastHr();

    return S_OK;
}

CRect CMainWnd::GetEffectiveClientRect()
{
    CRect rc;
    int iControls[] = { 0xFFFFFFFF, 0xFFFFFFFF, TRUE, idStatusBar, 0, 0 };
    ::GetEffectiveClientRect(m_hWnd, &rc, iControls);
    return rc;
}
