#pragma once
#include "../resource.h"
#include "ViewWnd.h"

class CMainWnd:
    public CWindowImpl<CMainWnd, CWindow, CFrameWinTraits>
{
public:
	CMainWnd();
    ~CMainWnd();

    HRESULT Create( int nCmdShow );

    static const DWORD dwWindowStyle = 
        WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN | WS_CLIPSIBLINGS;
    static const DWORD dwClassStyle = 
        CS_DBLCLKS | CS_DROPSHADOW;
    static const DWORD iWindowBackground = COLOR_APPWORKSPACE;

    // The function below does the same as DECLARE_WND_CLASS_EX macro,
    // that unfortunately has no ICON parameter.
    static CWndClassInfo& GetWndClassInfo()
    {
        static CWndClassInfo wc = 
        {
            {
                sizeof(WNDCLASSEX), dwClassStyle, StartWindowProc,
                    0, 0, NULL,
                    LoadIcon( _AtlBaseModule.GetModuleInstance(), MAKEINTRESOURCE(IDI_PATHFINDINGDEMO) ),
                    NULL,
                    (HBRUSH)(iWindowBackground + 1), NULL,
                    L"PathfindingDemo",
                    NULL
            },
            NULL,
            NULL,
            IDC_ARROW,
            TRUE, 0, _T("")
        };
        return wc;
    }

    BEGIN_MSG_MAP( CMainWnd )
    // Basic WMs
        MESSAGE_HANDLER( WM_CREATE,            OnCreate )
        MESSAGE_HANDLER( WM_DESTROY,           OnDestroy )
        MESSAGE_HANDLER( WM_SIZE,              OnSize )
        MESSAGE_HANDLER( WM_SETFOCUS,          OnSetFocus )

        COMMAND_ID_HANDLER( IDM_EXIT,         OnExit );
    //  MESSAGE_HANDLER( WM_GETMINMAXINFO,     OnGetMinMaxInfo )
    END_MSG_MAP()
private:
    CViewWnd m_View;
    HMENU m_hMenu;

    // Windows messages
    LRESULT OnCreate(UINT nMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnDestroy(UINT nMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnSize( UINT nMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled );
    LRESULT OnSetFocus( UINT nMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled );
    LRESULT OnGetMinMaxInfo( UINT nMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled );

    LRESULT OnExit(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
    {
        SendMessage(WM_CLOSE);
        return 0;
    }

    // The status bar
    static const UINT idStatusBar   = 201;
    CWindow m_wndStatus;

    CRect GetEffectiveClientRect();
};