#pragma once
#include "GridView.hpp"
#include "../Main/PathMapWin.h"
 
class CViewWnd:
    public CGridViewWnd<CViewWnd>
{
public:
    static const DWORD dwTimerFrequency = 25;

    CViewWnd( CWindow* pStatus );
    ~CViewWnd();

    HRESULT Create( CWindow& parent );

    void PaintCell( HDC dc, const CPoint& ptCell, const CRect& rcToPaint );

    HRESULT LoadBmp( LPCTSTR strBmp );

    HRESULT LoadBmp( UINT resID );

    BEGIN_MSG_MAP( CViewWnd )
        MESSAGE_HANDLER( WM_TIMER, OnWmTimer )
        MESSAGE_HANDLER( WM_KEYDOWN, OnWmKeyDown )
        MESSAGE_HANDLER( WM_CREATE, OnWmCreate )
        CHAIN_MSG_MAP( CGridViewWnd<CViewWnd> )
    END_MSG_MAP()

    static const int iUpdateFreq = 25;     // Interval to update the map, expressed in WM_TIMER ticks
    static const int iPixelsToUpdate = 44; // How many pixels to update.
private:
    void DrawArrow( HDC dc, const CRect& rcToPaint, BYTE dir );
    void PaintWithColor( HDC dc, const CRect& rcToPaint, COLORREF c );

    LRESULT OnWmTimer( UINT nMsg, WPARAM wParam,  LPARAM lParam, BOOL& bHandled );
    LRESULT OnWmKeyDown( UINT nMsg, WPARAM wParam,  LPARAM lParam, BOOL& bHandled );
    LRESULT OnWmCreate( UINT nMsg, WPARAM wParam,  LPARAM lParam, BOOL& bHandled );

    virtual void OnMouseClick( int iCtrl, DWORD vk );
    virtual void OnMouseInOut( int iCtrl, bool bIn );

    CPathMapWin m_map;

    // Memory DC that holds IDB_ARROWS bitmap
	HDC m_dcMem;
    HBITMAP m_bmpPrev;
    int m_cellTracking;

    static const int idTimer = 11;

    static const UINT s_MapsIDs[];
    int m_currMapID;

    CWindow * const m_pStatus;
};