#pragma once

#ifndef WINVER
#define WINVER 0x0501
#endif

#ifndef _WIN32_WINNT
#define _WIN32_WINNT 0x0501
#endif						

#ifndef _WIN32_WINDOWS
#define _WIN32_WINDOWS 0x0401
#endif

#define WIN32_LEAN_AND_MEAN
#define NOMINMAX
#include <windows.h>

#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <tchar.h>

#define _ATL_CSTRING_EXPLICIT_CONSTRUCTORS

#include <atlbase.h>
#include <atlstr.h>
#include <atlcoll.h>
#include <atlwin.h>
#include <atlfile.h>
#include <algorithm>
#include <atltypes.h>
#include <atltime.h>
#include <atlpath.h>
#include <commdlg.h>
#include <math.h>
#include <intrin.h>

inline HRESULT GetLastHr() { return HRESULT_FROM_WIN32(GetLastError()); }

// Function that takes HRESULT, calls FormatMessage API and returns the CString
CStringW ErrMsg(HRESULT hr);

typedef unsigned __int64 QWORD;
static const DWORD DWORD_MAX = 0xFFFFFFFF;
static const QWORD QWORD_MAX = 0xFFFFFFFFFFFFFFFFL;

inline QWORD PerfFrequency()
{
    LARGE_INTEGER res;
    QueryPerformanceFrequency(&res);
    return res.QuadPart;
}

inline QWORD PerfCounter()
{
    LARGE_INTEGER res;
    QueryPerformanceCounter(&res);
    return res.QuadPart;
}

#include <algorithm>

#ifdef _DEBUG
#define MyTrace AtlTrace
#else
inline void MyTrace(const char* lpszFormat, ...)
{
    CStringA res;
    va_list argptr;
    va_start(argptr, lpszFormat);
    res.FormatV(lpszFormat, argptr);
    va_end(argptr);
    OutputDebugStringA(res);
}
#endif
